
//
// icsSpyData.h - Vehicle Spy Data Structures
// Created: 9/25/99
// Last Updated: 10/30/2000
// Copyright 1999-2000 Intrepid Control Systems, Inc.
//
// this data file defines data constants used in Vehicle Spy and neoVI for C/C++ users
// the data is directed from the icsspyHardware COM interface and neoVI DLL
//

#define SPY_DATA_FILE 
 

/*
'// protocols
Public Enum icsspyHardwareProtocol
    icsspyProtocolCustom
    icsspyProtocolCAN
    icsspyProtocolGMLAN
    icsspyProtocolJ1850VPW
    icsspyProtocolJ1850PWM
    icsspyProtocolISO9141
    icsspyProtocolKeyword2000
    icsspyProtocolGM_ALDL_UART
    icsspyProtocolChryslerCCD
    icsspyProtocolChryslerSCI
    icsspyProtocolFordUBP
	icsspyProtocolBean
End Enum */

const SPY_PROTOCOL_CUSTOM = 0;
const SPY_PROTOCOL_CAN = 1;
const SPY_PROTOCOL_GMLAN = 2;
const SPY_PROTOCOL_J1850VPW = 3;
const SPY_PROTOCOL_J1850PWM = 4;
const SPY_PROTOCOL_ISO9141 = 5;
const SPY_PROTOCOL_Keyword2000 = 6;
const SPY_PROTOCOL_GM_ALDL_UART = 7;
const SPY_PROTOCOL_CHRYSLER_CCD = 8;
const SPY_PROTOCOL_CHRYSLER_SCI = 9;
const SPY_PROTOCOL_FORD_UBP = 10;
const SPY_PROTOCOL_BEAN = 11;

/*
'// these are bitmasks for the status bitfield
Public Enum icsSpyDataStatusBitfield
    icsSpyStatusGlobalError = 2 ^ 0
    icsSpyStatusTx = 2 ^ 1
    icsSpyStatusXtdFrame = 2 ^ 2
    icsSpyStatusRemoteFrame = 2 ^ 3
    icsSpyStatusErrCRCError = 2 ^ 4
    icsSpyStatusCANErrorPassive = 2 ^ 5
    icsSpyStatusErrIncompleteFrame = 2 ^ 6
    icsSpyStatusErrLostArbitration = 2 ^ 7
    icsSpyStatusErrUndefined = 2 ^ 8
    icsSpyStatusErrCANBusOff = 2 ^ 9
    icsSpyStatusErrCANErrorWarning = 2 ^ 10
    icsSpyStatusBusShortedPlus = 2 ^ 11
    icsSpyStatusBusShortedGnd = 2 ^ 12
    icsSpyStatusCheckSumError = 2 ^ 13
    icsSpyStatusErrBadMessageBitTimeError = 2 ^ 14
    icsSpyStatusIFRData = 2 ^ 15
    icsSpyStatusHardwareCommError = 2 ^ 16
    icsSpyStatusExpectedLengthError = 2 ^ 17
    icsSpyStatusIncomingNoMatch = 2 ^ 18
    icsSpyStatusBreak = 2 ^ 19
    icsSpyStatusAVT_VSIRecOverflow = 2 ^ 20
    icsSpyStatusTestTrigger = 2 ^ 21
    icsSpyStatusAudioCommentType = 2 ^ 22
    icsSpyStatusGPSDataValue = 2 ^ 23
    icsSpyStatusAnalogDigitalInputValue = 2 ^ 24
    icsSpyStatusTextCommentType = 2 ^ 25
    icsSpyStatusNetworkMessageType = 2 ^ 26
    icsSpyStatusVSI_TxUnderRun = 2 ^ 27
    icsSpyStatusVSI_IFR_CRCBit = 2 ^ 28
    icsSpyStatusInitMessage = 2 ^ 29
    icsSpyStatusHighSpeed = 2 ^ 30
End Enum
*/

// constants for the status bitfield
const long SPY_STATUS_GLOBAL_ERR = 0x01;
const long SPY_STATUS_TX_MSG = 0x02;
const long SPY_STATUS_XTD_FRAME = 0x04;
const long SPY_STATUS_REMOTE_FRAME = 0x08;

const long SPY_STATUS_CRC_ERROR = 0x10;
const long SPY_STATUS_CAN_ERROR_PASSIVE = 0x20;
const long SPY_STATUS_INCOMPLETE_FRAME = 0x40;
const long SPY_STATUS_LOST_ARBITRATION = 0x80;

const long SPY_STATUS_UNDEFINED_ERROR = 0x100;
const long SPY_STATUS_CAN_BUS_OFF = 0x200;
const long SPY_STATUS_CAN_ERROR_WARNING = 0x400;
const long SPY_STATUS_BUS_SHORTED_PLUS = 0x800;

const long SPY_STATUS_BUS_SHORTED_GND = 0x1000;
const long SPY_STATUS_CHECKSUM_ERROR = 0x2000;
const long SPY_STATUS_BAD_MESSAGE_BIT_TIME_ERROR = 0x4000;
const long SPY_STATUS_IFR_DATA = 0x8000;

const long SPY_STATUS_HARDWARE_COMM_ERROR = 0x10000;
const long SPY_STATUS_EXPECTED_LEN_ERROR = 0x20000;
const long SPY_STATUS_INCOMING_NO_MATCH = 0x40000;
const long SPY_STATUS_BREAK = 0x80000;

const long SPY_STATUS_AVSI_REC_OVERFLOW = 0x100000;
const long SPY_STATUS_TEST_TRIGGER = 0x200000;
const long SPY_STATUS_AUDIO_COMMENT = 0x400000;
const long SPY_STATUS_GPS_DATA = 0x800000;

const long SPY_STATUS_ANALOG_DIGITAL_INPUT = 0x1000000;
const long SPY_STATUS_TEXT_COMMENT = 0x2000000;
const long SPY_STATUS_NETWORK_MESSAGE_TYPE = 0x4000000;
const long SPY_STATUS_VSI_TX_UNDERRUN = 0x8000000;

const long SPY_STATUS_VSI_IFR_CRC_Bit = 0x10000000;
const long SPY_STATUS_INIT_MESSAGE = 0x20000000;
const long SPY_STATUS_HIGH_SPEED_MESSAGE = 0x40000000;

// The second status bitfield
/*
Public Enum icsSpyDataStatusBitfield2
    icsSpyStatusHasValue = 2 ^ 0
    icsSpyStatusValueIsBoolean = 2 ^ 1
    icsSpyStatusHighVoltage = 2 ^ 2
    icsSpyStatusLongMessage = 2 ^ 3
End Enum
*/

const long SPY_STATUS2_HAS_VALUE = 1;
const long SPY_STATUS2_VALUE_IS_BOOLEAN = 2;
const long SPY_STATUS2_HIGH_VOLTAGE = 4;
const long SPY_STATUS2_LONG_MESSAGE = 8;

/*
Public Type icsSpyMessage
    StatusBitField As Long '4
    StatusBitField2 As Long 'new '4
    TimeHardware As Long ' 4
    TimeHardware2 As Long 'new ' 4
    TimeSystem As Long ' 4
    TimeSystem2 As Long
    TimeStampID As Byte 'new ' 1
    TimeStampSystemID As Byte
    NetworkID As Byte 'new ' 1
    NodeID As Byte
    Protocol As Byte
    MessagePieceID As Byte ' 1
    ColorID As Byte '1
    NumberBytesHeader As Byte ' 1
    NumberBytesData As Byte ' 1
    DescriptionID As Integer ' 2
    ArbIDOrHeader As Long    '// Holds (up to 3 byte 1850 header or 29 bit CAN header) '4
    Data(1 To 8) As Byte '8
    AckBytes(1 To 8) As Byte 'new '8
    Value As Single ' 4
    MiscData As Byte
End Type */

typedef struct // matching C structure
    {
    unsigned long StatusBitField;	// 4
	unsigned long StatusBitField2;	// 4
    unsigned long TimeHardware;		// 4
	unsigned long TimeHardware2;	// 4
    unsigned long TimeSystem;		// 4
	unsigned long TimeSystem2;		// 4
	unsigned char TimeStampHardwareID;		// 1
	unsigned char TimeStampSystemID;
	unsigned char NetworkID;		// 1
	unsigned char NodeID;
	unsigned char Protocol;
	unsigned char MessagePieceID;	// 1
	unsigned char ColorID;			// 1
    unsigned char NumberBytesHeader;// 1
    unsigned char NumberBytesData;  // 1
	short DescriptionID;			// 2
    long ArbIDOrHeader;				// 4
    unsigned char Data[8];			
	unsigned char AckBytes[8];			
    float Value;
	unsigned char MiscData;
    }  icsSpyMessage;

/*
Public Type icsSpyMessageLong
    StatusBitField As Long ' 4
    StatusBitField2 As Long 'new '4
    TimeHardware As Long
    TimeHardware2 As Long 'new ' 4
    TimeSystem As Long '4
    TimeSystem2 As Long
    TimeStampID As Byte 'new ' 1
    TimeStampSystemID As Byte
    NetworkID As Byte 'new ' 1
    NodeID As Byte
    Protocol As Byte
    MessagePieceID As Byte ' 1
    ColorID As Byte ' 1
    NumberBytesHeader As Byte '
    NumberBytesData As Byte '2
    DescriptionID As Integer '2
    ArbIDOrHeader As Long    '// Holds (up to 3 byte 1850 header or 29 bit CAN header)
    DataMsb As Long
    DataLsb As Long
    AckBytes(1 To 8) As Byte 'new '8
    Value As Single
    MiscData As Byte
    
End Type*/

typedef struct // matching C structure
    {
    unsigned long StatusBitField;	// 4
	unsigned long StatusBitField2;	// 4
    unsigned long TimeHardware;		// 4
	unsigned long TimeHardware2;	// 4
    unsigned long TimeSystem;		// 4
	unsigned long TimeSystem2;		// 4
	unsigned char TimeStampHardwareID;		// 1
	unsigned char TimeStampSystemID;	// 1
	unsigned char NetworkID;		// 1
	unsigned char NodeID;			// 1
	unsigned char Protocol;			// 1 
	unsigned char MessagePieceID;	// 1
	unsigned char ColorID;			// 1
    unsigned char NumberBytesHeader;// 1
    unsigned char NumberBytesData;  // 1
	short DescriptionID;			// 2
    long ArbIDOrHeader;				// 4
    unsigned long DataMsb;
	unsigned long DataLsb;
	unsigned char AckBytes[8];			
    float Value;
	unsigned char MiscData;
    }  icsSpyMessageLong;



/*
Public Type icsSpyMessageJ1850
    StatusBitField As Long '4
    StatusBitField2 As Long 'new '4
    TimeHardware As Long '4
    TimeHardware2 As Long 'new ' 4
    TimeSystem As Long '4
    TimeSystem2 As Long
    TimeStampID As Byte 'new ' 1
    TimeStampSystemID As Byte
    NetworkID As Byte 'new ' 1
    NodeID As Byte
    Protocol As Byte
    MessagePieceID As Byte ' 1 new
    ColorID As Byte ' 1
    NumberBytesHeader As Byte '1
    NumberBytesData As Byte '1
    DescriptionID As Integer '2
    Header(1 To 4) As Byte  '4  '// Holds (up to 3 byte 1850 header or 29 bit CAN header)
    Data(1 To 8) As Byte '8
    AckBytes(1 To 8) As Byte 'new '8
    Value As Single '4
    MiscData As Byte
End Type */

typedef struct // matching C structure
    {
    unsigned long StatusBitField;	// 4
	unsigned long StatusBitField2;	// 4
    unsigned long TimeHardware;		// 4
	unsigned long TimeHardware2;	// 4
    unsigned long TimeSystem;		// 4
	unsigned long TimeSystem2;		// 4
	unsigned char TimeStampHardwareID;		// 1
	unsigned char TimeStampSystemID;	// 1
	unsigned char NetworkID;		// 1
	unsigned char NodeID;			// 1
	unsigned char Protocol;			// 1
	unsigned char MessagePieceID;	// 1
	unsigned char ColorID;			// 1
    unsigned char NumberBytesHeader;// 1
    unsigned char NumberBytesData;  // 1
	short DescriptionID;			// 2
    unsigned char Header[4];		// 4
    unsigned char Data[8];
	unsigned char AckBytes[8];			
    float Value;
	unsigned char MiscData;
    }  icsSpyMessageJ1850;

/*
Public Type icsSpyMessageGPS
    StatusBitField As Long  '4
    StatusBitField2 As Long 'new '4
    TimeHardware As Long    '4
    TimeHardware2 As Long 'new ' 4
    TimeSystem As Long '4
    TimeSystem2 As Long
    TimeStampID As Byte 'new ' 1
    TimeStampSystemID As Byte
    NetworkID As Byte 'new ' 1
    NodeID As Byte
    Protocol As Byte
    MessagePieceID As Byte ' 1
    ColorID As Byte ' 1
    GPSDataID As Integer    '2
    DescriptionID As Integer '2
    AckBytes(1 To 8) As Byte 'new '8
    Value1 As Double '8
    Value2 As Double '8
    MiscData As Byte
End Type */

typedef struct // matching C structure
    {
    unsigned long StatusBitField;	// 4
	unsigned long StatusBitField2;	// 4
    unsigned long TimeHardware;		// 4
	unsigned long TimeHardware2;	// 4
    unsigned long TimeSystem;		// 4
	unsigned long TimeSystem2;		// 4
	unsigned char TimeStampHardwareID;		// 1
	unsigned char TimeStampSystemID;
	unsigned char NetworkID;		// 1
	unsigned char NodeID;		// 1
	unsigned char Protocol;		// 1
	unsigned char MessagePieceID;	// 1
	unsigned char ColorID;			// 1
	short GPSDataID;
	short DescriptionID;			// 2
	unsigned char AckBytes[8];			
    double Value1; // 8
    double Value2;// 8
	unsigned char MiscData;
    }  icsSpyMessageGPS;


/*
Public Type icsSpyMessageAnalog
    StatusBitField As Long  '4
    StatusBitField2 As Long 'new '4
    TimeHardware As Long    '4
    TimeHardware2 As Long 'new ' 4
    TimeSystem As Long '4
    TimeSystem2 As Long
    TimeStampID As Byte 'new ' 1
    TimeStampSystemID As Byte
    NetworkID As Byte 'new ' 1
    NodeID As Byte
    Protocol As Byte
    MessagePieceID As Byte ' 1
    ColorID As Byte ' 1
    AIDataID As Integer    '2
    DescriptionID As Integer '2
    Value As Double '8
    HardwareIndex As Integer '2
    AckBytes(1 To 8) As Byte 'new '8
    iDummy As Integer '2
    lDummy As Long '4
    MiscData As Byte
End Type
 */

typedef struct // matching C structure
    {
    unsigned long StatusBitField;	// 4
	unsigned long StatusBitField2;	// 4
    unsigned long TimeHardware;		// 4
	unsigned long TimeHardware2;	// 4
    unsigned long TimeSystem;		// 4
	unsigned long TimeSystem2;		// 4
	unsigned char TimeStampHardwareID;		// 1
	unsigned char TimeStampSystemID;		// 1
	unsigned char NetworkID;		// 1
	unsigned char NodeID;		// 1
	unsigned char Protocol;
	unsigned char MessagePieceID;	// 1
	unsigned char ColorID;			// 1
	short AIDataID;
	short DescriptionID;			// 2
	double Value;
	short HardwareIndex;
	unsigned char AckBytes[8];
	short iDummy;
	long lDummy;
	unsigned char MiscData;
    }  icsSpyMessageAnalog;

/*
Public Enum icsspyHardwareTimeStampID
    icsspyTimeStampNone
    icsspyTimeStampVSI
    icsspyTimeStampAVT_716
    icsspyTimeStampNICAN
End Enum */

// timestamp id fields
const unsigned char  HARDWARE_TIMESTAMP_ID_NONE =0;
const unsigned char  HARDWARE_TIMESTAMP_ID_VSI = 1;
const unsigned char  HARDWARE_TIMESTAMP_ID_AVT_716 = 2;
const unsigned char HARDWARE_TIMESTAMP_ID_NI_CAN = 3;
const unsigned char HARDWARE_TIMESTAMP_ID_NEOVI = 4;
const unsigned char HARDWARE_TIMESTAMP_ID_AVT_717 = 5;

/*
Public Enum icsspySystemTimeStampID
    icsspyTimeStampNone
    icsspyTimeStampTimeGetTimeAPI
End Enum*/

const unsigned char SYSTEM_TIMESTAMP_ID_NONE = 0;
const unsigned char SYSTEM_TIMESTAMP_ID_TIMEGETTIME_API = 1;


/*
Public Type icsspyMsgTime
    SystemTimeStampID As Long
    SystemTime1 As Long
    SystemTime2 As Long
    HardwareTimeStampID As Long
    HardwareTime1 As Long
    HardwareTime2 As Long
End Enum */

typedef struct // matching C structure
    {
    unsigned long SystemTimeStampID;	// 4
	unsigned long SystemTime1;			// 4
    unsigned long SystemTime2;			// 4
	unsigned long HardwareTimeStampID;	// 4
    unsigned long HardwareTime1;		// 4
	unsigned long HardwareTime2;		// 4
	
    }  icsSpyMsgTime;


//////////////////////// AVT rec status bitfield
unsigned const  REC_STATUS_CRC_ERROR = 2^0;
unsigned const  REC_STATUS_INCOMPLETE_MSG = 2^1;
unsigned const  REC_STATUS_BREAK = 2^2;
unsigned const  REC_STATUS_IFR_DATA = 2^3;
unsigned const  REC_STATUS_LOST_ARB = 2^4;
unsigned const  REC_STATUS_TX_SUCCESS = 2^5;
unsigned const  REC_STATUS_FROM_DEV = 2^6;
unsigned const  REC_STATUS_BAD_MSG = 2^7;

